package br.com.rjconsultores.auditador.annotations;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * Anotao responsvel para auditar o campos que so listas.
 * 
 * @author wilian
 *
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface AuditarLista {

	/**
	 * Caso seja necessrio colocar um nome amigvel para o atributo, seno for informado o padro ser o nome do atributo da classe.
	 */
	String nome() default "";
	
	/**
	 * Indica que os atributos da lista so entidades e precisam ser auditados individualmente. O padro  comparar apenas se os itens da lista foram removidos ou adicionados.
	 * @return
	 */
	boolean auditarEntidades() default false;

}
