package br.com.rjconsultores.auditador.interfaces;

/**
 * Interface que dever ser implementada quando o objeto for auditado, interface estende a interface Cloneable.
 * 
 * @author wilian
 *
 * @param <T>
 */
public interface Auditavel<T> extends Cloneable {
	
	/**
	 * Mtodo dever ser implementado com o recurso de clonagem da Interface Cloneable. Executa o processo de clonagem do objeto para ser comparado com o alterado, executar esse mtodo logo aps recuperar o objeto do banco de dados.
	 *  
	 * @throws CloneNotSupportedException
	 */
	public void clonar() throws CloneNotSupportedException;
	
	/**
	 * Aps executar o mtodo "clonar" retorna o objeto clonado.
	 * 
	 * @return
	 * @throws CloneNotSupportedException
	 */
	public T getCloneObject() throws CloneNotSupportedException;
	
	/**
	 * Mtodo que descreve informaes do objeto quando o registro  criado/includo/excludo.
	 * @return
	 */
	public String getTextoInclusaoExclusao();
	
}
